tool
extends ColorRect
class_name GPUGrid

export var grid_size = Vector2(16,16) setget set_grid_size
var shader:ShaderMaterial = null
export var destroy_on_ready = true

# Called when the node enters the scene tree for the first time.
func _ready():
	if !Engine.editor_hint && destroy_on_ready:
		queue_free()
		return
	connect("resized",self,"resized")
	shader = ShaderMaterial.new()
	shader.shader = load("res://Shaders/grid.shader")
	material = shader
	if shader != null:
		shader.set_shader_param("grid_size",grid_size);
		shader.set_shader_param("size",get_global_rect().size)

# Called every frame. 'delta' is the elapsed time since the previous frame.
func resized():
	if shader != null:
		shader.set_shader_param("size",get_global_rect().size)
		
func set_grid_size(sz):
	grid_size = sz
	if shader != null:
		shader.set_shader_param("grid_size",grid_size);
